package pipeline

import (
    "github.com/hu17889/go_spider/core/common/com_interfaces"
    "github.com/hu17889/go_spider/core/common/page_items"
    "database/sql"
	_ "github.com/go-sql-driver/mysql"
    "log"
    "github.com/pquerna/ffjson/ffjson"
    // "regexp"

)

type PipelineMysql struct {
	pMysql *sql.DB

}

func NewPipelineMysql() *PipelineMysql {
	db, err := sql.Open("mysql", mysqlLink)
	if err != nil {
		panic("Open database error")
	}
   
    return &PipelineMysql{pMysql:db}
}

func (this *PipelineMysql) Process(items *page_items.PageItems, t com_interfaces.Task) {
    println("----------------------------------------------------------------------------------------------")
    println("Crawled url :\t" + items.GetRequest().GetUrl() + "\n")
    tag:=items.GetRequest().GetUrlTag()
    if tag=="item"{

        this.insertItem(items.GetAll())
    }

    if tag=="answer"{
        this.insertAnswer(items.GetAll())
    }
    
}

/**
 * [func description]
 * @param  {[type]} this *PipelineMysql) insertItem(item map[string]string [description]
 * @return {[type]}      [description]
 */
func (this *PipelineMysql) insertItem(item map[string]string) {

	stmt, err := this.pMysql.Prepare("insert into ask (origin_id,origin_url,origin_uid,source,title,content,answer_num,nick_name,gender,education_background,age,area,head,marriage,create_time) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)")
    defer stmt.Close()
 
    if err != nil {
        log.Println(err)
        return
    }

    _,err=stmt.Exec(item["origin_id"],item["origin_url"],item["originUserId"],"1",item["title"],item["content"],item["answerNum"],item["nick_name"],item["gender"],item["educationBackground"],item["age"],item["area"],item["head"],item["marriage"],item["createTime"])

    if err != nil {
        log.Println(err)
        return
    }

    //插入answer
    var answerList *AnswerList
    err=ffjson.Unmarshal([]byte(item["answers"]),&answerList)
    if err!=nil{
        log.Println(err)
    }
    astmt,err:=this.pMysql.Prepare("insert into answer (content,ask_origin_id,expert_name,expert_title,expert_head,answer_time) values(?,?,?,?,?,?)")
    if err!=nil{
        log.Println(err)
        return
    }
    defer astmt.Close()
    for _,answer:=range answerList.List{
        _,err=astmt.Exec(answer.Content,answer.AskOriginId,answer.ExpertName,answer.ExpertTitle,answer.ExpertHead,answer.AnswerTime)
        if err !=nil{
            log.Println(err)
        }
    }
    
}

func (this *PipelineMysql) insertAnswer(item map[string]string) {

 

    //插入answer
    var answerList *AnswerList
    err:=ffjson.Unmarshal([]byte(item["answers"]),&answerList)
    if err!=nil{
        log.Println(err)
        return
    }
    astmt,err:=this.pMysql.Prepare("insert into answer (content,ask_origin_id,expert_name,expert_title,expert_head,answer_time) values(?,?,?,?,?,?)")
    if err!=nil{
        log.Println(err)
        return
    }
    defer astmt.Close()
    for _,answer:=range answerList.List{
        _,err=astmt.Exec(answer.Content,answer.AskOriginId,answer.ExpertName,answer.ExpertTitle,answer.ExpertHead,answer.AnswerTime)
        if err !=nil{
            log.Println(err)
        }
    }
    
}

