// The example gets stock newses from site sina.com (http://live.sina.com.cn/zt/f/v/finance/globalnews1).
// The spider is continuous service.
// The stock api returns json result.
// It fetchs news at regular intervals that has been set in the config file.
// The result is saved in a file by PipelineFile.
package main

import (
    "github.com/hu17889/go_spider/core/common/page"
    "github.com/usual2970/util/spiders/pipeline"
    "github.com/hu17889/go_spider/core/spider"
    "github.com/PuerkitoBio/goquery"
    "github.com/hu17889/go_spider/core/common/request"
    "github.com/pquerna/ffjson/ffjson"
    "fmt"
    "strings"
    "regexp"
    "time"
    "net/http"
    "strconv"
    "flag"

)

type MyPageProcesser struct {
    startNewsId int
}

func NewMyPageProcesser() *MyPageProcesser {
    return &MyPageProcesser{}
}

var getAll *bool
var getPage *int

var baseUrl="http://www.psy525.cn"
var listUrl="http://www.psy525.cn/case/"
var answerUrl="http://www.psy525.cn/sys/ajax.ashx?t=showcasepublicanslist"
// Parse html dom here and record the parse result that we want to crawl.
// Package simplejson (https://github.com/bitly/go-simplejson) is used to parse data of json.
func (this *MyPageProcesser) Process(p *page.Page) {
    if !p.IsSucc() {
        println(p.Errormsg())
        return
    }
    tag:=p.GetUrlTag()
    query := p.GetHtmlParser()
    if tag=="list"{
        p.SetSkip(true)
        var reqs []*request.Request
        query.Find("#clist li").Each(func(i int, s *goquery.Selection) {

            url, _ := s.Find("a").Attr("href")
            req := request.NewRequest(baseUrl+url, "html", "item", "GET", "", nil, nil, nil, nil)
            reqs = append(reqs, req)
        })

        nextSelect:=query.Find("#page a").Last()
        if nextSelect.Text()=="下一页"{

            url,_:=nextSelect.Attr("href")


            pageR := regexp.MustCompile("\\_(\\d+)")
            pageMatches:=pageR.FindStringSubmatch(url)
            pageNum,_:=strconv.Atoi(pageMatches[1])
            page:=pageNum/20

            if *getAll || (*getPage>=page){
                req := request.NewRequest(listUrl+url, "html", "list", "GET", "", nil, nil, nil, nil)
                reqs = append(reqs, req)

            }

            
        }

        p.AddTargetRequestsWithParams(reqs)

    }
    if(tag=="item"){
       
        query := p.GetHtmlParser()

        title := strings.TrimSpace(query.Find("#c-que h1").Text())
        content := strings.TrimSpace(query.Find("#c-que p.que").Text())
        gender:=query.Find("#c-head p em").Eq(0).Text()
        age:=query.Find("#c-head p em").Eq(1).Text()
        educationBackground:=query.Find("#c-head p em").Eq(2).Text()
        marriage:=query.Find("#c-head p em").Eq(3).Text()
        area:=query.Find("#c-head p em").Eq(4).Text()
        nick_name:=query.Find("#c-head p a").Text()
        origin_url:=p.GetRequest().GetUrl()


        r := regexp.MustCompile("\\/(\\d+)")
        matches:=r.FindStringSubmatch(origin_url)
        origin_id:=matches[1]

        userUrl,_:=query.Find("#c-head a.avatar").Attr("href")
        uidR := regexp.MustCompile("u(\\d+)")
        uMatches:=uidR.FindStringSubmatch(userUrl)
        originUserId:=uMatches[1]

        head,_:=query.Find("#c-head a.avatar img").Attr("src")

        answerNum:=query.Find("#c-que .remark b").Text()

        tempTime:=query.Find("#c-que .remark i").Eq(1).Text()
        timeR:=regexp.MustCompile("(\\d{4}.*)")
        timeMatch:=timeR.FindStringSubmatch(tempTime)
        the_time, _ := time.Parse("2006年01月02日 15:04", timeMatch[1])
        createTime:=the_time.Format("2006-01-02 15:04:05")

        //answers
        var answers []*pipeline.Answer
        eidR := regexp.MustCompile("d(\\d+)")
        query.Find(".c-ans").Each(func( i int,s *goquery.Selection){
            answer:=&pipeline.Answer{}

            answer.Content=s.Find(".anstxt").Text()

            tempTime:=s.Find(".time").Eq(0).Text()

            timeMatch:=timeR.FindStringSubmatch(tempTime)
    
            the_time, _ := time.Parse("2006年01月02日 15:04", timeMatch[1])

            answer.AnswerTime=the_time.Format("2006-01-02 15:04:05")

            answer.AskOriginId=origin_id

            answer.ExpertName=s.Find(".dr .un").Text()

            answer.ExpertTitle=s.Find(".dr em").Text()


            expertUrl,_:=s.Find(".dr .un").Attr("href")
            eMatches:=eidR.FindStringSubmatch(expertUrl)
            answer.OriginExpertId=eMatches[1]

            expertHead,_:=s.Find(".dr .avatar img").Attr("src")
            answer.ExpertHead=expertHead

            answers= append(answers,answer)

        })
        answerList:=&pipeline.AnswerList{answers}
        answerJson,_:=ffjson.Marshal(answerList)

        p.AddField("title",title)
        p.AddField("content",content)
        p.AddField("gender",gender)
        p.AddField("age",age)
        p.AddField("educationBackground",educationBackground)
        p.AddField("marriage",marriage)
        p.AddField("area",area)
        p.AddField("nick_name",nick_name)
        p.AddField("origin_url",origin_url)
        p.AddField("origin_id",origin_id)
        p.AddField("originUserId",originUserId)
        p.AddField("head",head)
        p.AddField("answerNum",answerNum)
        p.AddField("createTime",createTime)

        p.AddField("answers",string(answerJson))

        answerNumInt,_:=strconv.Atoi(answerNum)
        var reqs []*request.Request
        if answerNumInt>3{
            for i:=1;i<=(answerNumInt/3)+1;i++{
                start:=i*3
                
                req:=request.NewRequest(answerUrl, "html", "answer", "POST", fmt.Sprintf("start=%s&parm=0_-1_2_%s",strconv.Itoa(start),origin_id), http.Header{}, nil, nil, nil)
                req=addHeader(req)
                reqs=append(reqs,req)
            }
            p.AddTargetRequestsWithParams(reqs)
        }

    }


    if tag=="answer"{
        postData:=p.GetRequest().GetPostdata()

        var answers []*pipeline.Answer
        eidR := regexp.MustCompile("d(\\d+)")
        timeR:=regexp.MustCompile("(\\d{4}.*)")
        idR:=regexp.MustCompile("0\\_\\-1\\_2\\_(\\d+)")

        idMatch:=idR.FindStringSubmatch(postData)
        origin_id:=idMatch[1]

        query.Find(".c-ans").Each(func( i int,s *goquery.Selection){
            answer:=&pipeline.Answer{}

            answer.Content=s.Find(".anstxt").Text()

            tempTime:=s.Find(".time").Eq(0).Text()

            timeMatch:=timeR.FindStringSubmatch(tempTime)
    
            the_time, _ := time.Parse("2006年01月02日 15:04", timeMatch[1])

            answer.AnswerTime=the_time.Format("2006-01-02 15:04:05")

            answer.AskOriginId=origin_id

            answer.ExpertName=s.Find(".dr .un").Text()

            answer.ExpertTitle=s.Find(".dr em").Text()


            expertUrl,_:=s.Find(".dr .un").Attr("href")
            eMatches:=eidR.FindStringSubmatch(expertUrl)
            answer.OriginExpertId=eMatches[1]

            expertHead,_:=s.Find(".dr .avatar img").Attr("src")
            answer.ExpertHead=expertHead

            answers= append(answers,answer)

        })
        answerList:=&pipeline.AnswerList{answers}
        answerJson,_:=ffjson.Marshal(answerList)
        p.AddField("answers",string(answerJson))
    }


    
    
}

func (this *MyPageProcesser) Finish() {
    fmt.Printf("TODO:before end spider \r\n")
}

func main() {
    // spider input:
    //  PageProcesser ;
    //  task name used in Pipeline for record;
    //  
    //  
    var reqs []*request.Request


    getAll=flag.Bool("all",false,"是否获取全部")
    getPage=flag.Int("page",2,"获取的页数")
    flag.Parse()
    println(*getAll)
    println(*getPage)
    url:="http://www.psy525.cn/case/caseopen.html"
    req := request.NewRequest(url, "html", "list", "GET", "", nil, nil, nil, nil)
    reqs=append(reqs,req)
    
    spider.NewSpider(NewMyPageProcesser(), "psy525").
        AddRequests(reqs). // start url, html is the responce type ("html" or "json" or "jsonp" or "text")
        AddPipeline(pipeline.NewPipelineMysql()).                                                                                   // Print result to std output                                                                      // Print result in file
        OpenFileLog("/tmp"). 
        SetThreadnum(5).                                                                                                         // Error info or other useful info in spider will be logged in file of defalt path like "WD/log/log.2014-9-1".                                                                                        // Sleep time between 1s and 3s.
        Run()

    //AddPipeline(pipeline.NewPipelineFile("/tmp/tmpfile")). // print result in file
}

func addHeader(req *request.Request) *request.Request {
    req.Header.Add("Content-Type","application/x-www-form-urlencoded; charset=UTF-8")
    req.Header.Add("Referer","http://www.psy525.cn/")
    return req
}

